function GenQuery(MTS_D, Query_D, window_size, variables, p, time_shiftings)

% This function generates and saves a query from the input MTS
% Inputs:
%     MTS_D:          The input folder containing the MTS time series files
%     Query_D:        The folder where the query will be saved
%     window_size:    Size of sliding window (typically 256, 512 or 1024) 
%     variables:      The ids of the features which are used in search
%     p:              The length of each searched time series (p(1)*window_size) is the actual length)
%     time_shiftings: The time delay between the succssive sequences
    

filelist=dir([MTS_D,'*.csv']);
% for demo perposes we have used the first flight
t = importdata([MTS_D filelist(1).name]);
q = cell(length(variables),1);   %% the time series
for i=1:length(variables)
   q{i} = t.data(1000+(i-1)*time_shiftings: 1000+(i-1)*time_shiftings -1 +window_size, variables(i)); 
end
if(~exist(Query_D,'dir'))
    mkdir(Query_D);
end
save([Query_D 'sample_query.mat'], 'q', 'p', 'time_shiftings', 'variables');
