function cand = FindCandidates(Index_D, q,feature,window_size, num_ref, threshold,Ref_D)
% Find candidates (MTS,offset pairs) for sequence q (from 'feature')based on 'num_ref' reference points
% 'Index_D' is the index dir
% 'Ref_D' contains reference point files 

p = length(q)/window_size; %number of sections of q

Ref_filename = [Ref_D '/RefPoints_F' num2str(feature) '.txt'];
r = load(Ref_filename);


%% Find candidate for each section of q ( recorded in mts_offset{sec} ) 
threshold = threshold/sqrt(p);
for sec = 1:p
    %extract one section of q
    sec_start = (sec-1)*window_size + 1;
    q_sec = q(sec_start:sec_start+window_size-1);
    
    %find a candidate set based on each refrence point
    t_range = cputime;
    for ref_i = 1:num_ref
        dist_qr = Lp_dist(r(:,ref_i),q_sec,2);
        foldername = [Index_D '/' num2str(feature) '/' num2str(ref_i)];
        %search candidates on index files (these files are pre-built for 'feature' using 'ref_i')
        mts_offset_byref{ref_i} = RangeQuery(foldername, dist_qr-threshold, dist_qr+threshold); 
    end
    
    %interset candidate sets based on reference points to obtain the candidate set for one section 
    %(mts_offset{sec} records the candidates based on each section)
    if num_ref>=2
        %first intersect candidates based on 1st and 2nd ref points 
        mts_offset{sec} = intersect(mts_offset_byref{1},mts_offset_byref{2},'rows');
    else %only one reference point
        mts_offset{sec} = mts_offset_byref{1};
    end
    for i = 3:num_ref
        mts_offset{sec} = intersect(mts_offset{sec},mts_offset_byref{i},'rows');
    end
    mts_offset{sec}(:,2) = mts_offset{sec}(:,2) - (sec-1)*window_size;
end

%% union candidates based on different sections to obtain the candidates for whole sequence q
if p >= 2
    cand = union(mts_offset{1},mts_offset{2},'rows');
else
    cand = mts_offset{1};
end
for i = 3:p
    cand = union(cand1,mts_offset{i},'rows');
end


