function cand = join_cand(cand1, cand2, time_shifting)
% Join two candidate set (mts, offset pairs)for variable1 and variable2 considering the time shifting
% there will be one more column in cand than cand1 and cand2

% cand1 and cand2 have been sorted by mts

MAX = max(size(cand1,1),size(cand2,1));
cand = zeros(MAX,3);

%% mts_start_end is a n*3 matrix, a row [A B C] denotes candidates from mts
%% A are from B to C in candidate set
mts_start_end1 = cluster_cand(cand1);
rows1 = size(mts_start_end1, 1);
mts_start_end2 = cluster_cand(cand2);
rows2 = size(mts_start_end2, 1);


current_row1 = 1;
current_row2 = 1;
num_cand = 0;
while current_row1 <= rows1 && current_row2 <= rows2
    %find the same mts in two candidate set
    while current_row1 <= rows1 && current_row2 <= rows2 && mts_start_end1(current_row1,1) ~=  mts_start_end2(current_row2,1)
        if mts_start_end1(current_row1,1) < mts_start_end2(current_row2,1)
            current_row1 = current_row1 + 1;
        else
            current_row2 = current_row2 + 1;
        end
    end
    if current_row1 > rows1 || current_row2 > rows2
        break;
    end
    %join only between the same mts
    start1 = mts_start_end1(current_row1,2);
    end1 = mts_start_end1(current_row1,3);
    start2 = mts_start_end2(current_row2,2);
    end2 = mts_start_end2(current_row2,3);
    for i = start2:end2
        ind = find(cand1(start1:end1,2) + time_shifting == cand2(i,2),1);
%        ind = find(cand2(i,2) - cand1(start1:end1,2) < time_shifting);
        if ~isempty(ind)
            ind = ind + start1 -1;
            num_cand = num_cand + 1;
            cand(num_cand,:) = [cand1(ind,:) cand2(i,2)];
        end
    end
    
    current_row1 = current_row1 + 1;
    current_row2 = current_row2 + 1;
end

cand(num_cand+1:MAX,:) = [];
    
            