function PairDist = PairDist_RandomPick(UTS_D,variable,num_MTS,num_pairs,window_size, lengths)

% randomly pick 'num_pairs' of subsequences with 'window_size' from 'UTS_D\variable'
% calculate pair-wise distance and show the histogram
% threshold for this variable can be chosen based on distance distribution

% lengths is an array containing lengths (number of the time stamps) for each MTS
% This can be generated by 'GetLengths.m'

foldername = [UTS_D '/' num2str(variable) '/'];
%lengths = load(MTS_length);%get length for each MTS

PairDist  =zeros(num_pairs,1);
for i = 1:num_pairs
    %if (mod(i,100)==0)
    %    fprintf('Processing pair %d\n',i);
    %end
    %each time randomly pick two subsequences
    rand_MTS  = ceil(rand(1,1)*num_MTS);
    rand_Offset  = ceil(rand(1,1) * (lengths(rand_MTS)-window_size+1));
    filename = [foldername num2str(rand_MTS) '.txt'];
    fid = fopen(filename,'rt');
    
    %fseek(fid,(rand_Offset-1)*(18),'bof');
    for j=1:rand_Offset-1
        fgetl(fid);
    end
    s1 = fscanf(fid,'%f',window_size);
    fclose(fid);

    rand_MTS2  = ceil(rand(1,1)*num_MTS);
    rand_Offset2  = ceil(rand(1,1) * (lengths(rand_MTS2)-window_size+1));
    filename = [foldername num2str(rand_MTS2) '.txt'];
    fid = fopen(filename,'rt');
    for j=1:rand_Offset2-1
        fgetl(fid);
    end
    
    %fseek(fid,(rand_Offset2-1)*(18),'bof');
    s2 = fscanf(fid,'%f',window_size);
    fclose(fid);
    PairDist(i) = Lp_dist(s1,s2,2);
end
[n x] = hist(PairDist,  num_pairs);
save(['n_' num2str(variable) '.mat'],'n');
save(['x_' num2str(variable) '.mat'],'x');
save(['pair_dist' num2str(variable) '.mat'], 'PairDist');
PairDist = sort(PairDist);
fprintf('Threshold for selectivity:\n0.0001:  %f\n0.001:   %f\n0.01:   %f\n',PairDist(1,1), PairDist(10,1), PairDist(100,1));
%figure,hist(PairDist,100);

