% Notices:
% 
% Copyright  2009 United States Government as represented by 
% the Administrator of the National Aeronautics and Space 
% Administration.  All Rights Reserved.

% Disclaimers
% 
% No Warranty: THE SUBJECT SOFTWARE IS PROVIDED "AS IS" WITHOUT 
% ANY WARRANTY OF ANY KIND, EITHER EXPRESSED, IMPLIED, OR 
% STATUTORY, INCLUDING, BUT NOT LIMITED TO, ANY WARRANTY 
% THAT THE SUBJECT SOFTWARE WILL CONFORM TO SPECIFICATIONS, 
% ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
% PARTICULAR PURPOSE, OR FREEDOM FROM INFRINGEMENT, ANY 
% WARRANTY THAT THE SUBJECT SOFTWARE WILL BE ERROR FREE, OR 
% ANY WARRANTY THAT DOCUMENTATION, IF PROVIDED, WILL CONFORM 
% TO THE SUBJECT SOFTWARE. THIS AGREEMENT DOES NOT, IN ANY 
% MANNER, CONSTITUTE AN ENDORSEMENT BY GOVERNMENT AGENCY OR 
% ANY PRIOR RECIPIENT OF ANY RESULTS, RESULTING DESIGNS, 
% HARDWARE, SOFTWARE PRODUCTS OR ANY OTHER APPLICATIONS 
% RESULTING FROM USE OF THE SUBJECT SOFTWARE.  FURTHER, 
% GOVERNMENT AGENCY DISCLAIMS ALL WARRANTIES AND LIABILITIES 
% REGARDING THIRD-PARTY SOFTWARE, IF PRESENT IN THE ORIGINAL 
% SOFTWARE, AND DISTRIBUTES IT "AS IS."
% 
% Waiver and Indemnity:  RECIPIENT AGREES TO WAIVE ANY 
% AND ALL CLAIMS AGAINST THE UNITED STATES GOVERNMENT, 
% ITS CONTRACTORS AND SUBCONTRACTORS, AS WELL AS ANY 
% PRIOR RECIPIENT.  IF RECIPIENT'S USE OF THE SUBJECT 
% SOFTWARE RESULTS IN ANY LIABILITIES, DEMANDS, DAMAGES, 
% EXPENSES OR LOSSES ARISING FROM SUCH USE, INCLUDING ANY 
% DAMAGES FROM PRODUCTS BASED ON, OR RESULTING FROM, 
% RECIPIENT'S USE OF THE SUBJECT SOFTWARE, RECIPIENT 
% SHALL INDEMNIFY AND HOLD HARMLESS THE UNITED STATES 
% GOVERNMENT, ITS CONTRACTORS AND SUBCONTRACTORS, AS WELL 
% AS ANY PRIOR RECIPIENT, TO THE EXTENT PERMITTED BY LAW.  
% RECIPIENT'S SOLE REMEDY FOR ANY SUCH MATTER SHALL BE THE 
% IMMEDIATE, UNILATERAL TERMINATION OF THIS AGREEMENT.


addpath('Build Index/');
addpath('Search/');
addpath('Threshold Setting/');

datafolder = 'Dataset/';
window_size = 256;  %% width of sliding window
features = [2 5 10 15];   %% features on which the index is built (you can use all the features in the dataset, the number of variables in the query will be a subset of this)
num_ref = 3;	    %% number of reference points used
eps1 = 1;           %% threshold for first variable in query
eps2 = 1;           %% threshold for second variable in query

%% Build Index
BatchBuildIndex(datafolder, [datafolder 'UTS_D'], [datafolder 'Index_D'],...
window_size, features, [datafolder 'Ref_D'], num_ref);

%% Generate a query
variables = [2 5];
p = ones(1,length(variables)); 
time_shiftings = 200;
GenQuery(datafolder, [datafolder 'Query_D/'], window_size, variables, p, time_shiftings);


%% Perform Search (query is provided in Query_D/query1_goaround.mat
nn = MTS_Search([datafolder 'UTS_D'], [datafolder 'Index_D'], window_size,...
    [datafolder 'Query_D/sample_query.mat'],[eps1 eps2], [datafolder 'Ref_D'],3);
